﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Text.RegularExpressions;
using System.Threading.Tasks;

namespace AdventOfCode2023.Day3
{
    public class Day3_1 : DayBase
    {
        string input = string.Empty;

        Regex rxSymbols = new Regex(@"[^\d\.\r\n]");
        Regex rxNumbers = new Regex(@"\d+");

        public Day3_1()
        {
            input = GetInput("Day3.txt");
        }

        public Day3_1(string testInput)
        {
            input = testInput;
        }

        public override string Execute()
        {
            List<Number> numbers = new List<Number>();

            var inputLines = input.Split("\r\n");
            var index = 0;
            foreach (var line in inputLines)
            {
                var matches = rxNumbers.Matches(line);
                foreach (Match match in matches)
                {
                    numbers.Add(new Number(int.Parse(match.Value), index, match.Index, match.Length));
                }

                index++;
            }

            index = 0;
            foreach (var line in inputLines)
            {
                var matches = rxSymbols.Matches(line);
                foreach (Match match in matches)
                {
                    var adjacentNumbers = numbers.Where(x => (x.XPosition >= (index - 1) && x.XPosition <= (index + 1)) && ((match.Index - 1 >= x.YPosition && match.Index - 1 <= (x.YPosition + x.Length - 1)) || (match.Index >= x.YPosition && match.Index <= (x.YPosition + x.Length - 1)) || (match.Index + 1 >= x.YPosition && match.Index + 1 <= (x.YPosition + x.Length - 1)))).ToList();
                    adjacentNumbers.ForEach(x => x.isPart = true);
                }

                index++;
            }

            return numbers.Where(x => x.isPart).Sum(x => x.Value).ToString();
        }
    }

    internal class Number
    {
        public int Value = 0;
        public int XPosition = 0;
        public int YPosition = 0;
        public int Length = 0;
        public bool isPart = false;

        public Number(int value, int xPosition, int yPosition, int length)
        {
            Value = value;
            XPosition = xPosition;
            YPosition = yPosition;
            Length = length;
        }
    }
}
