﻿using AdventOfCode2023.Day5;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Text.RegularExpressions;
using System.Threading.Tasks;

namespace AdventOfCode2023.Day6
{
    public class Day6_2 : DayBase
    {
        string input = string.Empty;

        Regex rxTime = new Regex(@"(?<=Time:[\s\d]+)\d+");
        Regex rxDistance = new Regex(@"(?<=Distance:[\s\d]+)\d+");

        public Day6_2()
        {
            input = GetInput("Day6.txt");
        }

        public Day6_2(string testInput)
        {
            input = testInput;
        }

        public override string Execute()
        {
            ulong winningMovesProduct = 0;

            var times = rxTime.Matches(input).Select(x => int.Parse(x.Value)).ToArray();
            var distances = rxDistance.Matches(input).Select(x => int.Parse(x.Value)).ToArray();

            var bigTime = ulong.Parse(string.Join("", times));
            var bigDistance = ulong.Parse(string.Join("", distances));

            var winningMoves = CreateRange(0, bigTime).Count(x => x * (bigTime - x) > bigDistance);
            winningMovesProduct = winningMovesProduct == 0 ? (ulong)winningMoves : (ulong)winningMoves * winningMovesProduct;

            return winningMovesProduct.ToString();
        }

        public IEnumerable<ulong> CreateRange(ulong start, ulong count)
        {
            var limit = start + count;

            while (start < limit)
            {
                yield return start;
                start++;
            }
        }
    }
}
